<!--
“Copyright 2020 L'esfera”

This file is part of L'esfera.

L'esfera is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <https://www.gnu.org/licenses/>.
-->

<template>
    <div>
        <b-modal id="node-editor" size="lg" @ok="saveNode">
            <h3 slot="modal-title">{{ node_data.name }}</h3>
            <b-form-textarea
              id="textarea"
              v-model="node_data.description"
              placeholder="Una descripció útil ..."
              rows="6"
              max-rows="12"
            ></b-form-textarea>
        </b-modal>
    </div>
</template>

<script>
import axios from 'axios';
import { eventBus } from '@/main.js';
export default {
    name: 'NodeEditor',
    props: { node_data: {} },
    data() {
        return {  }
    },
    methods: {
        saveNode: function () {
            var self = this
            if (this.node_data.id !== undefined) {
                // update existing node
                // (should remove html tags from description here)
                axios.patch(process.env.VUE_APP_API_SERVER + '/nodes/'+this.node_data.id, {
                    description: self.node_data.description,
                })
                .then(function () {
                    self.$emit("updateNode", self.node_data)
                })
                .catch(function (error) {
                    console.log(error);
                });
            } else {
                // create a new node
                axios.post(process.env.VUE_APP_API_SERVER + '/nodes', {
                    name: self.node_data.name,
                    description: self.node_data.description,
                    left_node_id: self.node_data.current_node_id
                })
                .then(response => (
                    this.$router.push({ path: '/node/' + response.data.id }),
                    eventBus.$emit("incNodeCount")
                ))
                .catch(function (error) {
                    console.log(error);
                });                
            }
        },
    }
}
</script>

<style scoped>

</style>
